function schema()
%SCHEMA  simple.ServerSocket class definition function.

    % package definition
    simplePackage = findpackage('simple');
    javaPackage = findpackage('javahandle_withcallbacks');
    javaClass = findclass(javaPackage, 'java.net.ServerSocket');
   
    % class definition
    simpleClass = schema.class(simplePackage, 'ServerSocket', javaClass);
   
    % define class methods
    % bind.m overloads java bind method
    m = schema.method(simpleClass, 'bind');
    s = m.Signature;
    s.varargin    = 'off';
    s.InputTypes  = {'handle'};
    s.OutputTypes = {};

    % accept.m overloads java accept method and adds communication protocol
    m = schema.method(simpleClass, 'accept');
    s = m.Signature;
    s.varargin    = 'off';
    s.InputTypes  = {'handle'};
    s.OutputTypes = {'string'};

    % add properties to this class
    % holds remote address as a matlab string
    p = schema.prop(simpleClass, 'address', 'string');
    p.FactoryValue = 'localhost';

    % holds remote port as a matlab int
    p = schema.prop(simpleClass, 'port', 'int16');
    p.FactoryValue = 2222;
    
    % holds a handle reference to the socket created in the accept method
    p = schema.prop(simpleClass, 'socket', 'handle');

end
