function connect(this)
%CONNECT overload of the java.net.Socket connect method
%
%   CONNECT(THIS) uses the simple.Socket properties address and port and the
%   superclass connect method to connect this client instance to a waiting 
%   simple.ServerSocket instance.
%
%   INPUTS:
%       THIS  : and instance of simple.Socket
%
%   See Also: simple.Socket

    % use the object address and port properties to connect to the remote
    % session via the superclass connect method
    inetAddress = java.net.InetSocketAddress(this.address, this.port);
    this.java.connect(inetAddress);

end