function schema
%SCHEMA  simple.Socket class definition function.

    % package definition
    simplePackage = findpackage('simple');
    javaPackage = findpackage('javahandle_withcallbacks');
    javaClass = findclass(javaPackage, 'java.net.Socket');
   
    % class definition
    simpleClass = schema.class(simplePackage, 'Socket', javaClass);
   
    % define class methods
    % connect.m overloads java connect method
    m = schema.method(simpleClass, 'connect');
    s = m.Signature;
    s.varargin    = 'off';
    s.InputTypes  = {'handle'};
    s.OutputTypes = {};

    % remoteEval.m matlab method for remote evaluation of matlab commands
    m = schema.method(simpleClass, 'remoteEval');
    s = m.Signature;
    s.varargin    = 'off';
    s.InputTypes  = {'handle', 'string'};
    s.OutputTypes = {'string'};

    % add properties to this class
    % holds remote address as a matlab string
    p = schema.prop(simpleClass, 'address', 'string');
    p.FactoryValue = 'localhost';

    % holds remote port as a matlab int
    p = schema.prop(simpleClass, 'port', 'int16');
    p.FactoryValue = 2222;

end
